<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.20"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>GTSBox: Project: Transfection2018</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">GTSBox
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.20 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="PageDoc"><div class="header">
  <div class="headertitle">
<div class="title">Project: Transfection2018 </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><h1>Data folder</h1>
<p>The data to be used for estimation is in <code>DataForEstimation</code>. The original data was obtained from <a href="https://zenodo.org/record/1228899">https://zenodo.org/record/1228899</a>, and was converted to the <code>.csv</code> files using the script <code><a class="el" href="../../d5/de3/_callconvert_froelich2018_data_8m.html">CallconvertFroelich2018Data.m</a></code> in <code>RawData</code> folder. In this study two experiments were done, therefore we have two different data files: 'Data_eGFP.csv' and 'Data_deGFP.csv'.</p>
<h1>Model specification</h1>
<p>In the <code>Model</code> folder consists of a symbolic model file <code>_syms.m</code> which is converted to <code>.mex</code> simulation files by AMICI using <code>makeAmiModel.m</code>. The <code>ModelSettings.m</code> contains model specific settings that should be modified by the user according to the model. Refer to the doc page on <code><a class="el" href="../../d5/d81/class_model_settings.html" title="Model setting class, specific to a project Note this is part of a template created in the GTSBOX tool...">ModelSettings</a></code> class.</p>
<h1>Estimation</h1>
<p>After compiling the model with the <code>makeAmiModel</code> script, we start with the estimation using the <code><a class="el" href="../../dd/dcf/_fit_transfection2018_8m.html">FitTransfection2018.m</a></code> script. We begin by initializing the paths with</p>
<pre class="fragment">initPaths()
</pre><p>Then, we need to initialize the options for the GTS and run the estimation </p><pre class="fragment">% get the GTS options: a default structure
GTSoptions=getGTSoptions();
</pre><h2>Estimation of the first stage</h2>
<p>We can modify options for the first stage as follows. </p><pre class="fragment">GTSoptions.FSopt.gloalgMaxeval=1e4; % optimization for the initial estimates.
GTSoptions.FSopt.runtype=1;         % type of first stage estimation
GTSoptions.compileflag=0;           % do not compile the model
GTSoptions.FSopt.parWorkers=50;     % number of threads to be used by parpool using 'local' cluster profile.
</pre><p>The estimation is then called using the <code><a class="el" href="../../d6/d19/_call_run_g_t_s_8m.html">CallRunGTS.m</a></code> function, by passing options to the first stage estimation through the options structure. </p><pre class="fragment">% 1. Run the first stage estimation
GTSoptions.FSopt.GLS.errorEstimation='PL';

% 1a. With PL-pool
CallRunGTS('Transfection2018',[], 'Data_eGFP',GTSoptions)
CallRunGTS('Transfection2018',[], 'Data_deGFP',GTSoptions)

% 1b. With AR-pool 
GTSoptions.FSopt.GLS.errorEstimation='AR';
CallRunGTS('Transfection2018',[], 'Data_eGFP',GTSoptions)
CallRunGTS('Transfection2018',[], 'Data_deGFP',GTSoptions)
</pre><h2>Estimation of the second stage</h2>
<p>We then run the second stage and using different options. The second stage can be optimized with either EM or with an optimizer (Nlopt in our case).</p>
<pre class="fragment">% Second stage and using different options
GTSoptions.FSopt.runtype=0;             % Do not run the first stage
GTSoptions.runSecondStage=1;            % Will run second stage

GTSoptions.SSopt.inpfiles={'Data_eGFP','Data_deGFP'};  % Passing more  1 input files..
</pre><h3>Estimation with an optimizer</h3>
<p>We can estimate a model for each experiment separately, without initializing the mean and covariance parameters. In this case, the empirical mean and covariance from the first stage estimates are taken.</p>
<pre class="fragment">% 2: Do not initialize the parameters, and treat two experiments separate
% from one another
GTSoptions.SSopt.Optimization='Optimizer';  % Use with an optimizer
GTSoptions.SSopt.jointExps=0;               % Do not joins datasets together
GTSoptions.SSopt.initialbeta0=[];
GTSoptions.SSopt.initialD0=[];
GTSoptions.SSopt.fname_append='Ex1_';       % Result file is appended with the string Ex_1
CallRunGTS('Transfection2018', [],[],GTSoptions);
</pre><p>We can add the bounds for the parameter to be estimated: </p><pre class="fragment">% 3. With specification of the bounds for the optimizer
GTSoptions.SSopt.initialbeta0=[];
GTSoptions.SSopt.initialD0=[];
GTSoptions.SSopt.optim.lower_bounds=[repmat(-10,1,10),repmat(-1,1,10)];
GTSoptions.SSopt.optim.upper_bounds=[repmat(10,1,10),repmat(1,1,10)];
GTSoptions.SSopt.fname_append='Ex2_';
CallRunGTS('Transfection2018', [],[],GTSoptions)
</pre><p>We can initialize the parameters and estimate a common mean and covariance for the both the datasets: </p><pre class="fragment">% 4. With initialization of the parameters
GTSoptions.SSopt.jointExps=1;
GTSoptions.SSopt.initialbeta0=[-2   -2.7    5.    0.1037    2.0328];
GTSoptions.SSopt.initialD0=eye(length(GTSoptions.SSopt.initialbeta0));
GTSoptions.SSopt.optim.lower_bounds=[];
GTSoptions.SSopt.optim.upper_bounds=[];
GTSoptions.SSopt.fname_append='Ex3_';
CallRunGTS('Transfection2018', [],[],GTSoptions)
</pre><p>We can also provide a user specific function to carry out the optimization. We provided our own objective function, such that we can estimate some variance and mean parameters to be the same in the experiments. </p><pre class="fragment">% 5. With a user specified fnhandle and covariate mapping function
GTSoptions.SSopt.fname_append='Ex4_';
GTSoptions.SSopt.jointExps=1;
GTSoptions.SSopt.covariate_flag=[zeros(1,236),ones(1,394)];
GTSoptions.SSopt.initialbeta0=[-2  -2.4   -2.7    5.    0.1037    2.0328];
GTSoptions.SSopt.initialD0=eye(length(GTSoptions.SSopt.initialbeta0));
GTSoptions.SSopt.optim.fnHandle=@SSObjectiveFn;   % user defined objective function
GTSoptions.SSopt.optim.fnParamMapper=@getParameterMatFn;% user defined function that maps parameter vectors to the form used in the objective function
GTSoptions.SSopt.CovariateFn=@getAimultiExp; % user defined function handle that returns the design matrix for each cell
CallRunGTS('Transfection2018', [],[],GTSoptions)
</pre><p>We can also provide a user-defined function to carry out the optimization. We provided our own objective function, such that we can estimate some variance and mean parameters to be the same in the experiments; a mapping function that converts vectors of parameters to the mean and covariance structures.</p>
<h3>Estimation with EM</h3>
<p>We can also estimate using the EM by changing the Optimization option.</p>
<pre class="fragment">% 6. With out covariates for the fixed effects, treating each experiment separate
GTSoptions=getGTSoptions();
GTSoptions.FSopt.runtype=0;
GTSoptions.compileflag=0;
GTSoptions.runSecondStage=1;           % Will run sec stage
GTSoptions.SSopt.inpfiles={'Data_eGFP','Data_deGFP'};  % Passing more than 1 input files..

GTSoptions.SSopt.Optimization='LGTS_EM';
GTSoptions.SSopt.jointExps=0;
GTSoptions.SSopt.fname_append='Ex5_';
CallRunGTS('Transfection2018', [],[],GTSoptions)
</pre><p>We can again estimate a common mean and covariance for both the datasets with EM with and without initializing the mean and covariance. </p><pre class="fragment">% 7. Treating both experiments together
GTSoptions.SSopt.jointExps=1;
GTSoptions.SSopt.fname_append='Ex6_';
CallRunGTS('Transfection2018', [],[],GTSoptions)
</pre><p>We can again estimate a common mean and covariance for both the datasets with EM with and without initializing the mean and covariance. </p><pre class="fragment">% 8. With initialization, and treating both experiments together
GTSoptions.SSopt.initialbeta0=[-2    -2.7    5.    0.1037    2.0328];
GTSoptions.SSopt.initialD0=eye(length(GTSoptions.SSopt.initialbeta0));
GTSoptions.SSopt.fname_append='Ex7_';
CallRunGTS('Transfection2018', [],[],GTSoptions)
</pre><p>We can also provide a function that generates a design matrix for the fixed effects with <code>GTSoptions.SSopt.CovariateFn</code>. </p><pre class="fragment">% 9. With initialization, and covariate on the fixed terms
GTSoptions.SSopt.initialbeta0=[-2  -2.4   -2.7    5.    0.1037    2.0328];
GTSoptions.SSopt.CovariateFn=@getAimultiExp;
GTSoptions.SSopt.fname_append='Ex8_';
CallRunGTS('Transfection2018', [],[],GTSoptions);
</pre><h1>Analysis Notebook folder</h1>
<p>All analysis is done in the <code>Jupyter</code> notebook in the <code>AnalysisNotebook</code> folder. </p>
</div></div><!-- contents -->
</div><!-- PageDoc -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Dec 3 2020 14:53:30 for GTSBox by&#160;<a href="http://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.8.20
</small></address>
</body>
</html>
